/* Monopoloy Game
*  Steve Parker
*  Just to see if I can
*
*  Monopoly is a game by Hasbro. I've emailed them and asked what
*  their attitude to my game is; they have not replied.
*
*  As such, this is a learning project and not intended
*  to infringe anyone's copyright. 
*  I have had an email from Hasbro asking me to call them; I have
*  not yet had chance (11/Nov/2000).
*  Friday 17/Nov/2000 I phoned Sue Jones at Hasbro, who asked me
*  to send her screenshots, etc. 
* 
*  To protect everyone's copyright, any distribution of this is 
*  based on the following terms:
* 
*  This code (c) Steve Parker
*  Not to be included in any other program or used as the basis for
*       any other program.
*  Not to be used for anything other than learning C.
*/

#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <netdb.h>
#include <ctype.h>
#include "monopoly.h"

void notify (char *x)
{
  if (text == 1)
    printf ("%s", x);
  if (text == 0) {
    gtk_text_insert (GTK_TEXT (mytext), small_font, NULL, NULL, x, strlen (x));
  }
}

/*
gboolean cash (int player, int value, int recipient)
{
  int res, i;
// recipient is a player number, or zero for Free Parking, Bank, etc.  
  if ((value > 0) || (Cash[player] + value > 0)) {
    Cash[player] += value;
    return TRUE;
  }
  else {
    // This transaction will make the player bankrupt. 
     // Note that this can only happen to you whilst 
     // it's your go, ie. player==Player. 
    res = audit (player);
    if (res < (-value)) {
      if (text == 0) {
	sprintf (note, "You're Bankrupt!");
	gui_show_text ("Quit", note, strlen (note), 200, 200);
      }
      // They couldn't succesfully raise the funds...
       // Give whatever they've got to the recipient. 
      for (i = 0; i < 40; i++)
	if (Owns[i] == player) {
	  Owns[i] = recipient;
	  send_structured_packet (OWNS, i, recipient, "");
	}
      if (recipient != 0)
	OutOfJailFree[recipient] += OutOfJailFree[player];
    }
    else {
      sprintf (note, "You're bankrupt, but selling property can redeem you.\n");
      notify (note);
    }
  }
}
*/

void next_player ()
{
  threw_double = 0;
  Player++;
  if (Player > NoOfPlayers)
    Player = 1;
  while (Quit[Player] == 1) {
    Player++;
    if (Player > NoOfPlayers)
      Player = 1;
  }
}

void quit (int player)
{
  int i;
  for (i = 0; i < 40; i++)
    if (Owns[i] == player) {
      Owns[i] = 0;
      Board[i].NoOfHouses = 0;
      send_structured_packet (OWNS, i, 0, "");
      send_structured_packet (HOUSE, i, 0, "");
      gui_show_houses (i);
    }
  send_structured_packet (QUIT, player, 1, "");
  next_player ();
  send_structured_packet (PLAYER, 0, Player, "");
}

void pass_go (int i)
{
  printf ("%s passes go!\n", Names[i]);
  Cash[i] += 200;
  Lap[i]++;
  send_structured_packet (CASH, i, Cash[i], "");
}

void move_player (int player, int loc)
{
  //sprintf(note, "Player %d moves to %d.\n", player, loc);
  //notify(note);
  if (loc > 39) {
    loc = loc % 40;
    pass_go (player);
  }
  while (loc < 0)
    loc += 40;
  if (text == 0)
    move_pointer (player, loc);
  Location[player] = loc;
}

void logme ()
{
#ifdef DEBUG
  if (1 == 1) {
    FILE *logfile;
    logfile = fopen ("log.txt", "a");
    fprintf (logfile, "%s", log);
    fclose (logfile);
  }
#else
  ;
#endif
}

void logstat (int p)
{
  sprintf (log, "%s has %d, is on %2d = %-30s; InJail=%d, OutOfJailFree=%d, Lap=%d\n", Names[p], Cash[p], Location[p],
	   Board[Location[p]].Name, InJail[p], OutOfJailFree[p], Lap[p]);
  logme ();
}

void init_game (int NoOfPlayers)
{
  int i;

#ifdef DEBUG
  FILE *logfile;
  logfile = fopen ("log.txt", "w");
  fprintf (logfile, "New Game\n");
  fclose (logfile);
#endif

  // Initialise random number ... 
  // time_t is a long int, 
  // srand() takes a unsigned int.
  // So we divide by four to be sure...
  i = time (NULL) % 12345;
  sprintf (log, "Srand value is %d\n", i);
  logme ();
  srand (i);			// default is 1.
  sprintf (Names[0], "Nobody");
  for (i = 1; i <= NoOfPlayers; i++) {
    Location[i] = 0;
    Lap[i] = 0;
    OutOfJailFree[i] = 0;
    InJail[i] = 0;
    Quit[i] = 0;
    Cash[i] = 1500;
  }
  for (i = 0; i < 40; i++) {
    Owns[i] = 0;
    Board[i].NoOfHouses = 0;
  }
  FreeParking = 50;
}

char *to_lower (char *s)
{
  char *t;

  t = s;
  while ((*s++ = tolower (*s)));
  s = t;
  return s;
}

void set_default_rules ()
{
  // Only if no "rules" file found.
  rules = 0;
  rules |= RULE_CANT_BUY_IF_BROKE;
  rules |= RULE_THREE_AND_IN;
  rules |= RULE_FREE_PARKING;
  rules |= RULE_400_FOR_GO;
//  rules |= RULE_LIMITED_BUILDINGS;
  rules |= RULE_BUY_BEFORE_SHAKE;
//  rules |= RULE_TIMELIMIT;
//  rules |= RULE_COLLECT_RENT_IN_JAIL;
  rules |= RULE_BALANCED_HOUSES;
  rules |= RULE_FIRST_LAP;
}

void show_rules ()
{

  printf ("----- GAME RULES ----\n");
  printf ("Can't buy if Broke:\t\t%s\n", (rules & RULE_CANT_BUY_IF_BROKE) ? "CAN'T" : "CAN");
  printf ("Three shakes means Jail:\t%s\n", (rules & RULE_THREE_AND_IN) ? "YES" : "NO");
  printf ("Get 400 for landing on Go:\t%s\n", (rules & RULE_400_FOR_GO) ? "YES" : "NO");
  printf ("Limited Buildings Available:\t%s\n", (rules & RULE_LIMITED_BUILDINGS) ? "YES" : "NO");
  printf ("Buy/Sell only before Shaking:\t%s\n", (rules & RULE_BUY_BEFORE_SHAKE) ? "YES" : "NO");
  printf ("Timelimited Game:\t\t%s\n", (rules & RULE_TIMELIMIT) ? "YES" : "NO");
  printf ("Can collect rent while in Jail:\t%s\n", (rules & RULE_COLLECT_RENT_IN_JAIL) ? "YES" : "NO");
  printf ("Houses must be balanced:\t%s\n", (rules & RULE_BALANCED_HOUSES) ? "YES" : "NO");
  printf ("Can buy on first lap:\t%s\n", (rules & RULE_FIRST_LAP) ? "YES" : "NO");
  printf ("----- GAME RULES ----\n");
}

void init_board ()
{
  Square s;
  FILE *config;
  //char *info;
  int i, j;
  char rule[255];
  char item[255];
  int val;

  config = fopen ("conf", "r");
  if (!config) {
    printf ("Cannot open config file \"conf\". This file is required\n");
    printf ("for Monopoly. It sets the street names, prices, rents, etc.\n");
    exit (2);
  }
  for (j = 0; j < 40; j++) {
    fscanf (config, "%d:%d:%d:%d:%d:%d:%d:%d:%d:%d:%d:%d:%d:%d:\n", &i, &s.Colour, &s.Cost, &s.MortgageValue, &s.CostofHouses,
	    &s.Rent[0], &s.Rent[1], &s.Rent[2], &s.Rent[3], &s.Rent[4], &s.Rent[5], &s.OneOtherInSet, &s.TwoOtherInSet,
	    &s.ThirdOtherInSet);
    fgets (s.Name, 30, config);
    s.Name[strlen (s.Name) - 1] = '\0';
    s.Mortgaged = 0;
    Board[j] = s;
  }
  fclose (config);

  rules = 0;
  config = fopen ("rules", "r");
  if (!config)
    set_default_rules ();
  else {
    while (fgets (rule, 255, config)) {
      if (sscanf (rule, "%s %d", item, &val) == 2) {
	if ((val != 1) && (val != 0))
	  item[0] = '#';
	if ((item[0] != '#') && (item[0] != ';') && (item[0] != '/')) {
	  if (!strcmp (item, "RULE_CANT_BUY_IF_BROKE"))
	    rules |= RULE_CANT_BUY_IF_BROKE * val;
	  if (!strcmp (item, "RULE_THREE_AND_IN"))
	    rules |= RULE_THREE_AND_IN * val;
	  if (!strcmp (item, "RULE_FREE_PARKING"))
	    rules |= RULE_FREE_PARKING * val;
	  if (!strcmp (item, "RULE_400_FOR_GO"))
	    rules |= RULE_400_FOR_GO * val;
	  if (!strcmp (item, "RULE_LIMITED_BUILDINGS"))
	    rules |= RULE_LIMITED_BUILDINGS * val;
	  if (!strcmp (item, "RULE_BUY_BEFORE_SHAKE"))
	    rules |= RULE_BUY_BEFORE_SHAKE * val;
	  if (!strcmp (item, "RULE_TIMELIMIT"))
	    rules |= RULE_TIMELIMIT * val;
	  if (!strcmp (item, "RULE_COLLECT_RENT_IN_JAIL"))
	    rules |= RULE_COLLECT_RENT_IN_JAIL * val;
	  if (!strcmp (item, "RULE_BALANCED_HOUSES"))
	    rules |= RULE_BALANCED_HOUSES * val;
	  if (!strcmp (item, "RULE_FIRST_LAP"))
	    rules |= RULE_FIRST_LAP * val;
	}
      }

    }
    fclose (config);
  }
  show_rules ();
}

char *colour_name (int i)
{
  char *col;
  col = (char *) malloc (50);

  switch (i) {
  case 7:
    strcpy (col, "Utilities");
    break;
  case 8:
    strcpy (col, "Stations");
    break;
  case 9:
    strcpy (col, "Brown");
    break;
  case 10:
    strcpy (col, "Orange");
    break;
  case 11:
    strcpy (col, "Blue");
    break;
  case 12:
    strcpy (col, "Red");
    break;
  case 13:
    strcpy (col, "Yellow");
    break;
  case 14:
    strcpy (col, "Pink");
    break;
  case 15:
    strcpy (col, "Green");
    break;
  case 16:
    strcpy (col, "Dark Blue");
    break;
  }
  return col;
}

void join_game (char *buf)
{
/* Here we send out acceptance of the game. We can also
	send our "Name" by which we will
	be known during the course of the game.  */
  int res;

  open_port (0);
  res = send_packet (buf, 0, strlen (buf));
  close_port (0);

/* Note that we may be on the same machine as the "master" who is still
   receiving packets from other players; this could be a while, since
   they may not have started the game yet ...
*/
  receive_update ();
}

void usage ()
{

  printf ("Usage: monopoly -n MyName [ -s ServerName | -p NoOfPlayers ] [ -t ]\n");
  exit (1);
}

int get_players (int myargc, char *myargv[])
{
  char *buf;
  int res;
  buf = (char *) malloc (200);
  int c;
  int client_or_server;
  struct in_addr yourip;
  struct hostent *h;
  char *youripstr = (char *) malloc (20);
  char myname[255];
  char server[255];
  int istext;

  istext = 0;
  NoOfPlayers = 4;
  sprintf (myname, "undefined");
  client_or_server = 0;
  while ((c = getopt (myargc, myargv, "tn:s:p:")) != -1) {
    switch (c) {
    case 't':
      istext = 1;
      break;
    case 'n':
      sprintf (myname, "%s", optarg);
      break;
    case 's':
      sprintf (server, "%s", optarg);
      client_or_server |= 2;
      break;
    case 'p':
      NoOfPlayers = atoi (optarg);
      client_or_server |= 1;
      break;
    default:
      usage ();
      break;
    }				// switch
  }				// getopt
  if ((client_or_server == 3) || (client_or_server == 0)) {
    usage ();
  }
  if (!strcmp (myname, "undefined"))
    usage ();

#ifdef DEBUG
  printf ("C or S: %d, MyName %s\n", client_or_server, myname);
#endif
  if (client_or_server == 1) {
#ifdef iowneverything
    {
      int i;
      for (i = 0; i < 40; i++)
	if (Board[i].Colour > 6)
	  Owns[i] = 1;
    }
#endif

    strcpy (Names[1], myname);
    fflush (stdin);
    master_wait_on_players ();
    res = 1;
  }

  if (client_or_server == 2) {
    notify ("Joining a Monopoly Game.\n\n\n");
    fflush (stdin);
/*
	Here we need to open a socket we will be listening on ...
	And find out the port number for MYPORT ...
*/
/* We set the "master"s inet stuff here; even the "master" must know this, because it is
   sent out to all other players.
*/

    h = (struct hostent *) gethostbyname (server);
    if (h == NULL) {		// get the host info
      herror ("gethostbyname");
      exit (1);
    }

    strcpy (youripstr, inet_ntoa (*((struct in_addr *) h->h_addr)));
    your_addr[1].sin_family = AF_INET;
    your_addr[1].sin_port = htons (MYPORT);
    inet_aton (youripstr, &yourip);

    your_addr[1].sin_addr = yourip;
    bzero (&(your_addr[1].sin_zero), 8);
// Of course, we ask the user for their name...
    your_addr[0].sin_family = AF_INET;
    your_addr[0].sin_port = htons (MYPORT);
    inet_aton (youripstr, &yourip);
    your_addr[0].sin_addr = yourip;
    bzero (&(your_addr[0].sin_zero), 8);

#ifdef DEBUG
    printf ("Calling start_receive\n");
#endif
    MYPORT = start_receive ();
#ifdef DEBUG
    printf ("Back from start_receive\n");
#endif
    sprintf (buf, "%d %s", MYPORT, myname);
#ifdef DEBUG
    printf ("MYPORT=%d.\n", MYPORT);
#endif
    join_game (buf);
    free (youripstr);
    res = 0;
  }
  // The "text" variable had to be 0 until now...
  // here we set it to what getopt() told us.

  text = istext;

  if (text == 0)
    gui_start (myargc, myargv);
  fflush (stdin);
  free (buf);
  return res;
}

void show_street (int loc)
{
  if (text)
    text_show_street (loc);
  else
    gui_show_street (loc);
}

void outofjail (int player)
{
  if (InJail[player] == 0)
    return;

  if (text == 0) {
    gui_outofjail (player);
#ifdef DEBUG
    printf ("Back from GUI\n");
#endif
  }
  else {
    notify ("You're in Jail... buy out.\n");
    notify ("Cashing you out with 50 whether you've got it or not...\n");
    notify ("We should offer you the option of shaking a double\n");
    if (OutOfJailFree[player] > 0) {
      OutOfJailFree[player]--;
      sprintf (note, "Using your Get Out Of %s Free Card.\n", Board[10].Name);
      notify (note);
    }
    else {
      Cash[player] -= 50;
    }
    InJail[player] = 0;
    send_structured_packet (JAIL, player, 0, "");
    send_structured_packet (CASH, player, Cash[player], "");
    send_structured_packet (LOCATION, player, Location[player], "");
  }
}

int get_rent (int i)
{
  int owner, rent;
  owner = Owns[i];
  if (owner == 0)
    rent = 0;
  else if (Board[i].Colour >= 9) {
    rent = Board[i].Rent[Board[i].NoOfHouses];
    if ((Board[i].NoOfHouses == 0) && (own_set (owner, i) == 0))
      rent *= 2;
  }
  if (Board[i].Colour == 7) {	// Utilities
    if (Owns[Board[i].OneOtherInSet] == Owns[i]) {
#ifdef DEBUG
      printf ("S/He owns both Utilities ... 10* dice value = 10 * %d = %d\n", dice_val, 10 * dice_val);
#endif
      rent = Board[i].Rent[1] * dice_val;
#ifdef DEBUG
      printf ("Board[i].Rent[0]=%d; Rent[1]=%d\n", Board[i].Rent[0], Board[i].Rent[1]);
#endif
    }
    else {
#ifdef DEBUG
      printf ("S/He owns only one Utility ... 4* dice value = 4 * %d = %d\n", dice_val, 4 * dice_val);
#endif
      rent = Board[i].Rent[0] * dice_val;
    }
  }
  if (Board[i].Colour == 8) {	// Stations
    rent = 0;
    if (Owns[Board[i].OneOtherInSet] == Owns[i])
      rent += 1;
    if (Owns[Board[i].TwoOtherInSet] == Owns[i])
      rent += 1;
    if (Owns[Board[i].ThirdOtherInSet] == Owns[i])
      rent += 1;
    rent = Board[i].Rent[rent];
    if (Owns[i] == 0)
      rent = 0;
  }

  if (Board[i].Mortgaged == 1) {
    rent = 0;
#ifdef DEBUG
    printf ("Board %d (%s) is mortgaged! No Rent!\n", i, Board[i].Name);
#endif
  }

  return rent;
}

int what_do_i_own (int player, int verbose)
{
  int res = 0;
  if (text)
    res = text_what_do_i_own (player, verbose);
  else
    res = gui_what_do_i_own (player, verbose);
  return res;
}

int own_set (int player, int i)
{
  int res;
  if ((Owns[i] == player) &&
      ((Owns[Board[i].OneOtherInSet] == player) || (Board[i].OneOtherInSet == 0)) &&
      ((Owns[Board[i].TwoOtherInSet] == player) || (Board[i].TwoOtherInSet == 0)) &&
      ((Owns[Board[i].ThirdOtherInSet] == player) || (Board[i].ThirdOtherInSet == 0)))
    res = 0;
  else
    res = 1;

  if ((Board[i].Mortgaged == 1) || (Board[Board[i].OneOtherInSet].Mortgaged == 1)
      || (Board[Board[i].TwoOtherInSet].Mortgaged == 1)
      || (Board[Board[i].ThirdOtherInSet].Mortgaged == 1))
    res = 1;

  return res;
}

int houses_okay (int i, int proposed)
{
  int j[3];
// cannot have 2 houses on one street without at least one on the others in the set.
// similarly, cannot build a 3rd with only one on another in the set.

  // See RULE_BALANCED_HOUSES for details.

  if (proposed > 5)
    return 1;			// the text interface could ask this...
  if (proposed == Board[i].NoOfHouses)
    return 1;			// the GUI could ask this ...
  j[0] = Board[i].OneOtherInSet;
  j[1] = Board[i].TwoOtherInSet;
  j[2] = Board[i].ThirdOtherInSet;

  if (((Board[j[0]].NoOfHouses + 1 != proposed) &&
       (Board[j[0]].NoOfHouses != proposed) && (Board[j[0]].NoOfHouses - 1 != proposed)) && (j[0] != 0))
    return j[0];

  if (((Board[j[1]].NoOfHouses + 1 != proposed) &&
       (Board[j[1]].NoOfHouses != proposed) && (Board[j[1]].NoOfHouses - 1 != proposed)) && (j[1] != 0))
    return j[1];

  if (((Board[j[2]].NoOfHouses + 1 != proposed) &&
       (Board[j[2]].NoOfHouses != proposed) && (Board[j[2]].NoOfHouses - 1 != proposed)) && (j[2] != 0))
    return j[2];

  return 0;
/* We didn't really have to check if j[x]!=0 because we would return 0 
   in that case anyway (assuming One Two ThirdOtherInSet are in order
   - ie, not 0,23,11).
*/
}

int buy_houses (int player)
{
  int i, j, skip, sets, res;
  int CanBuy[40];

  j = 1;
  sets = 0;
  skip = 0;
  i = what_do_i_own (player, 0);
  if (i == 0) {
    notify ("Sorry, you don't own any streets.\n");
  }
  for (i = 0; i < 40; i++) {
    CanBuy[i] = 0;
    if (own_set (player, i) == 0)
      if (Board[i].Colour >= 9) {
	res = houses_okay (i, Board[i].NoOfHouses + 1);
	// Houses can be built on this site (not a station, etc)
	if (Board[i].NoOfHouses == 5) {
	  sprintf (note, "%s has already got an hotel.\n", Board[i].Name);
	  notify (note);
	}
	else if ((Board[i].CostofHouses > Cash[player]) && ((rules & RULE_CANT_BUY_IF_BROKE) == RULE_CANT_BUY_IF_BROKE)) {
	  sprintf (note, "Sorry, you can't afford houses on %s.\n", Board[i].Name);
	  notify (note);
	}
	else if (res != 0) {
	  sprintf (note, "%s already has more houses than %s.\n", Board[i].Name, Board[res].Name);
	  notify (note);
	}
	else {
	  CanBuy[j++] = i;
	  if (skip != Board[i].Colour)
	    sets++;
	  skip = Board[i].Colour;	// Not perfect if alternating colours, but this
	  // doesn't happen on the default board...
	}
      }
  }				// for

  if (j == 1) {
    notify ("Sorry, you don't own any sets of streets on which you can build.\n");
    return 0;
  }
  else {
    char *s;
    res = j + 1;
    s = (char *) malloc (2);
    printf ("You own %d set(s) of streets you can build on. Please choose a street.\n", sets);
    for (i = 1; i < j; i++) {
      printf ("\n%3d) %-12s %-22s  %d house(s) at the moment. Houses cost %3d.\n", i,
	      colour_name (Board[CanBuy[i]].Colour), Board[CanBuy[i]].Name,
	      Board[CanBuy[i]].NoOfHouses, Board[CanBuy[i]].CostofHouses);
      printf ("       Rent:  Site: %3d  1: %3d  2: %3d  3: %3d  4: %4d  Hotel: %4d.\n",
	      Board[CanBuy[i]].Rent[0], Board[CanBuy[i]].Rent[1], Board[CanBuy[i]].Rent[2],
	      Board[CanBuy[i]].Rent[3], Board[CanBuy[i]].Rent[4], Board[CanBuy[i]].Rent[5]);
    }
    while (res >= j) {
      res = getnum ("Please choose a street (0 to quit): ");
    }
    if (res > 0) {
      printf ("You chose %d - %s\n", res, Board[CanBuy[res]].Name);
      Board[CanBuy[res]].NoOfHouses++;
      if (text == 0)
	gui_show_houses (CanBuy[res]);
      Cash[player] -= Board[CanBuy[res]].CostofHouses;
      printf ("Added a house to %s.\n", Board[CanBuy[res]].Name);
      send_structured_packet (HOUSE, CanBuy[res], Board[CanBuy[res]].NoOfHouses, "");
      send_structured_packet (CASH, player, Cash[player], "");
    }
  }
  return res;
}

void buy_street (int player)
{
  char ans;

  if (Board[Location[player]].Colour >= 7) {
    if (Owns[Location[player]] == player) {
      sprintf (note, "You already own %s.\n", Board[Location[player]].Name);
      notify (note);
    }
    else if (Owns[Location[player]] == 0) {
      if (Cash[player] >= Board[Location[player]].Cost) {
	char msg[1000];
	char msg2[200];
	int i;

	if (text == 1)
	  show_street (Location[player]);
	sprintf (msg, "Do you want to buy %s for %d?\n", Board[Location[player]].Name, Board[Location[player]].Cost);
	i = Board[Location[player]].OneOtherInSet;
	if (i != 0) {
	  if (Owns[i] == player)
	    sprintf (msg2, "You own %s.\n", Board[i].Name);
	  else
	    sprintf (msg2, "%s owns %s.\n", Names[Owns[i]], Board[i].Name);
	  strcat (msg, msg2);
	}
	i = Board[Location[player]].TwoOtherInSet;
	if (i != 0) {
	  if (Owns[i] == player)
	    sprintf (msg2, "You own %s.\n", Board[i].Name);
	  else
	    sprintf (msg2, "%s owns %s.\n", Names[Owns[i]], Board[i].Name);
	  strcat (msg, msg2);
	}
	i = Board[Location[player]].ThirdOtherInSet;
	if (i != 0) {
	  if (Owns[i] == player)
	    sprintf (msg2, "You own %s.\n", Board[i].Name);
	  else
	    sprintf (msg2, "%s owns %s.\n", Names[Owns[i]], Board[i].Name);
	  strcat (msg, msg2);
	}
	ans = getYN (msg, "Yes", "No");
	if (ans) {
#ifdef DEBUG
	  printf ("It's all yours!\n");
#endif
	  Owns[Location[player]] = player;
	  Cash[player] -= Board[Location[player]].Cost;
	  send_structured_packet (OWNS, Location[Player], Player, "");
	  send_structured_packet (CASH, Player, Cash[Player], "");
	  if (text == 0)
	    gui_show_owns_street (Location[Player], Player);
	}
      }
      else {
	sprintf (note, "Sorry, smallwallet. You can't have it!\n");
	notify (note);
	/*if (text==0) 
	   gui_show_text("Not enough cash!", note, strlen(note), 200, 70); */
      }
    }
    else {
      sprintf (note, "Sorry, %s owns %s.\n", Names[Owns[Location[player]]], Board[Location[player]].Name);
      notify (note);
    }
  }
}


int process_interact (char *s)
{
  int stop = 0;
  char msg[200];

#ifdef DEBUG
  printf ("info: button pressed: %s.\n", s);
#endif

  if ((!strcmp (s, "cash")) || (!strcmp (s, "c"))) {
    if (text)
      printf ("Cash: %d.\n", Cash[Player]);
    else {
      sprintf (msg, "Cash: %d.\n", Cash[Player]);
      gui_show_text ("Cash Status", msg, strlen (msg), 200, 70);
    }
  }
  if (!strncmp (s, "chat", 4)) {
    char *msg;
    int p;
    int i;
    int n;
    if (text == 1) {
      i = sscanf (s, "chat %d %n", &p, &n);
      msg = s + n;
      if (strlen (msg) == 0)
	i = 0;
    }
    else {
      msg = (char *) malloc (200);
      i = gui_chat (&p, msg);
    }
    // not working with GUI yet
    if ((text == 1) && (i >= 1)) {
      printf ("Sending '%s' to Player %d\n", msg, p);
      send_structured_packet (CHAT, Player, p, msg);
    }
    else
      printf ("i=%d\n", i);
    if (text == 0)
      free (msg);
  }
  if ((!strcmp (s, "shake")) || (!strcmp (s, "")) || (!strcmp (s, "end")) || (!strcmp (s, "k"))) {
    sprintf (note, "%s rolls the dice...\n", Names[Player]);
    notify (note);
    stop = 1;
  }
  if (!strcmp (s, "make"))
    printf ("I suspect that you want to ^C to the Unix shell...\n");
  if ((!strcmp (s, "house")) || (!strcmp (s, "h"))) {
    if (text == 1)
      while (buy_houses (Player) != 0);
    else
      gui_buy_sell_houses ();
  }
  if ((!strcmp (s, "rules")) || (!strcmp (s, "r"))) {
    show_rules ();
  }
  if ((!strcmp (s, "quit")) || (!strcmp (s, "q"))) {
    quit (Player);
  }
  if ((!strcmp (s, "card")) || (!strcmp (s, "a"))) {
    show_street (Location[Player]);
  }
  if ((!strcmp (s, "own")) || (!strcmp (s, "o"))) {
    what_do_i_own (Player, 1);
  }
  if ((!strcmp (s, "taken")) || (!strcmp (s, "t"))) {
    what_do_i_own (-1, 1);
  }
  if ((!strcmp (s, "jail"))) {
    // Only in GUI mode
    if (InJail[MyPlayerNum] == 0)
      sprintf (note, "You're not in %s.\nOut of %s Free Cards: %d.\n", Board[10].Name, Board[10].Name, OutOfJailFree[Player]);
    else
      sprintf (note, "You're in %s.\nOut of %s Free Cards: %d.\n", Board[10].Name, Board[10].Name, OutOfJailFree[Player]);
    gui_show_text ("Jail Status", note, strlen (note), 200, 70);
  }
  if ((!strcmp (s, "mortgage")) || (!strcmp (s, "m"))) {
    if (text == 0)
      gui_buy_sell_mortgage (Player);
    else {
      sprintf (note, "Mortgages unimplemented in text UI");
      notify (note);
    }
  }
  if ((!strcmp (s, "free")) || (!strcmp (s, "f"))) {
    what_do_i_own (0, 1);
  }
  if ((!strcmp (s, "parking")) || (!strcmp (s, "p"))) {
    sprintf (msg, "Free Parking: %d.\n", FreeParking);
    if (text == 0)
      gui_show_text ("Free Parking", msg, strlen (msg), 300, 70);
    else
      printf ("%s", msg);
  }
  if ((!strcmp (s, "sets")) || (!strcmp (s, "s"))) {
    int j, skip = 0;
    for (j = 0; j < 40; j++)
      if (((own_set (Player, j)) == 0) && (skip != Board[j].Colour)) {
	sprintf (note, "You own the %s set.\n", colour_name (Board[j].Colour));
	notify (note);
	skip = Board[j].Colour;
      }
  }
  if (!strcmp (s, "help")) {
    if (text == 0) {
      sprintf (note, "Sorry, GUI help not yet implemented.\nBluff your way through!\n");
      gui_show_text ("Help", note, strlen (note), 200, 70);
    }
    else {
      printf ("Commands recognised: (note that this list is out-of-date)\n");
      printf ("a) cArd       : Show the card for this street\n");
      printf ("c) Cash       : How loaded am I?\n");
      printf ("-) Chat       : chat n Message\n");
      printf ("e) hElp       : This list\n");
      printf ("f) Free       : What streets are still for sale?\n");
      printf ("h) House      : Buy a house\n");
      printf ("k) shaKe      : Shake my dice already!\n");
      printf ("o) Own        : Tell me what streets I own\n");
      printf ("p) Parking    : How much in Free Parking?\n");
      printf ("r) Rules      : Show the Rules\n");
      printf ("s) Sets       : Tell me what sets I own\n");
      printf ("t) Taken      : Tell me what streets are Taken\n");
    }
  }
  return stop;
}


void interact (int player)
{
  char *s;
  int stop = 0;

  if (text == 1) {
    printf ("You are on %s. ", Board[Location[player]].Name);
    printf ("You have %d pounds\n", Cash[player]);
    printf ("Type \"help\" for help. Type \"shake\" or RETURN to continue.\n");
  }

  if (text == 0) {
#ifdef DEBUG
    printf ("You're the active player! :-)\n");
#endif
    add_interact_dialog ();
  }
  else {
    s = (char *) malloc (50);
    while (!stop) {
      printf ("%s $ ", Names[Player]);
      fgets (s, 50, stdin);
      s[strlen (s) - 1] = '\0';
      stop = process_interact (s);
    }
    free (s);
  }
}

void display_board (int NoOfPlayers, int P)
{
  int i;
  P = 0;

  if (text == 1) {
    printf ("\nPlayer		      Cash	Location\n");
    for (i = 1; i <= NoOfPlayers; i++) {
      if ((P == 0) || (i == P)) {
	if (i == Player)
	  printf ("*");
	else
	  printf (" ");
	printf ("%-30s%5d	%s\n", Names[i], Cash[i], Board[Location[i]].Name);
      }
    }
  }
  else
    gdk_window_raise (window->window);

}

int shake ()
{
  int dice[2];
  int tot;

  dice[0] = 1 + (int) (6.0 * rand () / (RAND_MAX + 1.0));
  dice[1] = 1 + (int) (6.0 * rand () / (RAND_MAX + 1.0));

/*#ifdef cheat
  dice[1]=dice[0];
#endif*/

#ifdef cheat
  if ((Location[MyPlayerNum] < 33) && (Location[MyPlayerNum] > 28))
    if (12 + Location[MyPlayerNum] >= 30) {
      dice[0] = (int) (30 - Location[MyPlayerNum]) / 2;
      dice[1] = 30 - dice[0] - Location[MyPlayerNum];
    }
#endif

  if (dice[0] == dice[1])
    threw_double++;
  else
    threw_double = 0;
  tot = dice[0] + dice[1];
  if (text == 0) {
    gui_show_dice (dice[0], dice[1]);
    send_structured_packet (DICE, dice[0], dice[1], "");
  }
  return tot;
}


void NotOwned (int player, int loc)
{
  Square s;
  s = Board[loc];

  // Groups 0..8 inclusive are some kind of system square; 9+ are standard buyable properties.
  // However, when not owned, Utilities and Stations are "standard".
  if (s.Colour < 7) {
    SystemSquare (player, Location[player]);
  }
  else {
    if (Cash[player] >= s.Cost) {
      notify ("Nobody owns that ...You can buy if it you want.\n");
    }
    else {
      sprintf (note, "Nobody owns %s but you can't afford %d!\n", s.Name, s.Cost);
      notify (note);
      if (text == 0) {
	gui_show_text ("Not enough cash!", note, strlen (note), 200, 70);
      }
    }
  }				// else System Square
}

void OwnedSquare (int player, int myloc)
{
  int owner, rent, nohouses;

  owner = Owns[myloc];
  nohouses = Board[myloc].NoOfHouses;
  rent = get_rent (myloc);

  if (Board[myloc].Colour >= 9) {
    if (Board[myloc].Mortgaged == 0)
      sprintf (note, "%s Has %d house(s), you owe %d to %s\n", Board[myloc].Name, nohouses, rent, Names[owner]);
    else
      sprintf (note, "%s is mortgaged - no rent for %s!\n", Board[myloc].Name, Names[owner]);
  }
  else {
    if (Board[myloc].Mortgaged == 0)
      sprintf (note, "%s is owned by %s, you owe %d\n", Board[myloc].Name, Names[owner], rent);
    else
      sprintf (note, "%s is owned by %s but is mortgaged - no rent!\n", Board[myloc].Name, Names[owner]);
  }
  notify (note);
  if (text == 0)
    gui_show_text ("Landed on Owned Square", note, strlen (note), 400, 100);
  Cash[player] -= rent;
  Cash[owner] += rent;
  sprintf (note, "%s has %d pounds.\n", Names[player], Cash[player]);
  notify (note);
  sprintf (note, "%s pays %d rent to %s for %s.\n", Names[player], rent, Names[owner], Board[myloc].Name);
  send_structured_packet (INFO, 0, 0, note);
  send_structured_packet (CASH, player, Cash[player], "");
  send_structured_packet (CASH, owner, Cash[owner], "");
}

void landed_on_square (int player, int myloc)
{

  sprintf (note, "*** You just landed on %s ***\n", Board[Location[player]].Name);
  notify (note);
  if (Owns[myloc] == player) {
    sprintf (note, "You own %s!\n", Board[Location[player]].Name);
    notify (note);
    if (text == 0)
      gui_show_text ("Landed on your own Square", note, strlen (note), 200, 70);
  }
  else {
    if (Owns[myloc] == 0) {
      if ((Lap[player] == 0) && ((rules & RULE_FIRST_LAP) == 0)) {
	if (Board[myloc].Colour >= 7) {
	  printf ("You are on %s.\n", Board[Location[player]].Name);
	  printf ("Sorry you can't buy property on your first lap.\n");
	}
	else
	  SystemSquare (player, myloc);
      }
      else {
	NotOwned (player, myloc);
	if (Board[myloc].Colour >= 7) {
	  // Only give the chance to buy if it's a buyable street!
	  buy_street (player);
	}
      }
    }
    else {
      OwnedSquare (player, myloc);
    }
  }
}

void street_repairs (int player, int house, int hotel)
{
  int i, tot = 0;

  for (i = 0; i < 40; i++) {
    if (Owns[i] == player)
      switch (Board[i].NoOfHouses) {
      case 0:
	break;
      case 1:
      case 2:
      case 3:
      case 4:
	tot += (house * Board[i].NoOfHouses);
	break;
      case 5:
	tot += hotel;
      }
  }
  sprintf (note, "Total cost of street repairs: %d.\n", tot);
  notify (note);
  if (text == 0)
    gui_show_text ("Street Repairs", note, strlen (note), 200, 70);
  Cash[player] -= tot;
  printf ("%s has %d.\n", Names[player], Cash[player]);
  send_structured_packet (CASH, player, Cash[player], "");
}

void chance (int player)
{
  char msg[16][200];
  int value[12];
  int i;

#ifdef DEBUG
  printf ("IN CHANCE\n");
#endif
  // Collect / Pay money.
  strcpy (msg[0], "You have won a crossword competition.\nCollect 100.");
  value[0] = 100;
  strcpy (msg[1], "Bank pays you dividend of 50.");
  value[1] = 50;
  strcpy (msg[2], "Your building loan matures.\nReceive 150.");
  value[2] = 150;
  strcpy (msg[3], "Pay school fees of 150.");
  value[3] = -150;
  strcpy (msg[4], "Drunk in Charge.\nFine 20.");
  value[4] = -20;
  strcpy (msg[5], "Speeding fine 15.");
  value[5] = -15;
  // Move to a place.
  sprintf (msg[6], "Advance to %s.\nIf you pass %s collect 200.", Board[11].Name, Board[0].Name);
  value[6] = 11;
  sprintf (msg[7], "Advance to %s\n", Board[0].Name);
  value[7] = 0;
  sprintf (msg[8], "Advance to %s.\nIf you pass %s collect 200.", Board[24].Name, Board[0].Name);
  value[8] = 24;
  sprintf (msg[9], "Advance to %s.", Board[39].Name);
  // Only don't get "If you pass Go collect 200" because you can't pass Go on the way to Mayfair.
  value[9] = 39;
  sprintf (msg[10], "Advance to %s.\nIf you pass %s collect 200.", Board[15].Name, Board[0].Name);
  value[10] = 15;
  strcpy (msg[11], "Go back three spaces.");
  value[11] = -3;
  // Street Repairs.
  strcpy (msg[12], "Make general repairs on all of your buildings.\nFor each house pay 25.\nFor each hotel pay 100.");
  strcpy (msg[13], "You are assessed for street repairs.\n40 per house.\n115 per hotel.");
  // Jail.
  sprintf (msg[14], "Get out of %s Free.\nThis card may be kept until needed or sold.", Board[10].Name);
  sprintf (msg[15], "Go to %s.\nMove directly to %s.\nDo not pass %s.\nDo not collect 200.", Board[10].Name, Board[10].Name,
	   Board[0].Name);

  i = (int) (16.0 * rand () / (RAND_MAX + 1.0));
#ifdef DEBUG
  printf ("CHANCE: i=%d (%s)\n", i, msg[i]);
#endif

  notify (msg[i]);
  if (text == 0)
    gui_show_text ("Chance", msg[i], strlen (msg[i]), 500, 200);
  sprintf (note, "Chance: %s\n", msg[i]);
  send_structured_packet (INFO, 0, 0, note);
  switch (i) {
  case 0:
  case 1:
  case 2:
  case 3:
  case 4:
  case 5:
    Cash[player] += value[i];
    send_structured_packet (CASH, player, Cash[player], "");
    break;
  case 6:
  case 7:
  case 8:
  case 9:
  case 10:
    if (i == 7)
      Cash[player] += 200;
    if (value[i] < Location[player])
      Cash[player] += 200;
    move_player (player, value[i]);
    send_structured_packet (CASH, player, Cash[player], "");
    send_structured_packet (LOCATION, player, Location[player], "");
    landed_on_square (player, Location[player]);
    break;
  case 11:
    move_player (player, Location[player] + value[i]);
    send_structured_packet (LOCATION, player, Location[player], "");
    send_structured_packet (LOCATION, player, Location[player], "");
    landed_on_square (player, Location[player]);
    break;
  case 12:
    street_repairs (player, 25, 100);
    break;
  case 13:
    street_repairs (player, 40, 115);
    break;
  case 14:
    OutOfJailFree[player]++;
    break;
  case 15:
    threw_double = 0;
    InJail[player] = 1;
    move_player (player, 10);
    send_structured_packet (JAIL, player, 1, "");
    send_structured_packet (LOCATION, player, Location[player], "");
    break;
  }
#ifdef DEBUG
  printf ("End of Chance. Cash is %d  Location is %d (%s) .\n", Cash[player], Location[player], Board[Location[player]].Name);
#endif
}

void community_chest (int player)
{
  char msg[16][200];
  char value[16];
  int i;

  // Collect / Pay money.
  strcpy (msg[0], "You have won second prize in a beauty contest.\nCollect 10.");
  value[0] = 10;
  strcpy (msg[1], "Annuity Matures.\nCollect 100");
  value[1] = 100;
  strcpy (msg[2], "Receive Interest on\n7% preference shares\n25");
  value[2] = 25;
  strcpy (msg[3], "Income Tax Refund.\nCollect 20");
  value[3] = 20;
  strcpy (msg[4], "You Inherit 100");
  value[4] = 100;
  strcpy (msg[5], "Bank Error in your favour\nCollect 200");
  value[5] = 200;
  strcpy (msg[6], "Pay Hospital 100");
  value[6] = -100;
  strcpy (msg[7], "Doctor's Fee\nPay 50");
  value[7] = -50;
  strcpy (msg[8], "From sale of stock\nyou get 50");
  value[8] = 50;
  strcpy (msg[9], "Pay your insurance\npremium 50");
  value[9] = -50;
  sprintf (msg[10], "Go back to %s", Board[1].Name);
  value[10] = 1;
  sprintf (msg[11], "Advance to %s", Board[0].Name);
  value[11] = 0;
  // These two are more tricky...
  strcpy (msg[12], "Pay a 10 Fine or take a Chance");
  value[12] = 10;
  strcpy (msg[13], "It is your birthday.\nCollect 10 from each player.");
  value[13] = 10;
  // These two are the same as Chance.
  sprintf (msg[14], "Get out of %s Free.\nThis card may be kept until needed or sold.", Board[10].Name);
  sprintf (msg[15], "Go to %s.\nMove directly to %s.\nDo not pass %s.\nDo not collect 200.", Board[10].Name, Board[10].Name,
	   Board[0].Name);

  i = (int) (16.0 * rand () / (RAND_MAX + 1.0));
  notify (msg[i]);
  if (text == 0)
    gui_show_text ("Community Chest", msg[i], strlen (msg[i]), 500, 200);
  sprintf (note, "Community Chest: %s.\n", msg[i]);
  send_structured_packet (INFO, 0, 0, note);

  switch (i) {
  case 0:
  case 1:
  case 2:
  case 3:
  case 4:
  case 5:
  case 6:
  case 7:
  case 8:
  case 9:
    Cash[player] += value[i];
    send_structured_packet (CASH, player, Cash[player], "");
    break;
  case 10:
    move_player (player, value[i]);
    send_structured_packet (LOCATION, player, Location[player], "");
    landed_on_square (player, Location[player]);
    break;
  case 11:
    move_player (player, value[i]);
    send_structured_packet (LOCATION, player, Location[player], "");
    landed_on_square (player, Location[player]);
    break;
  case 12:{
      char msg[20];
      char s;
      sprintf (msg, "%d Fine or Chance?", value[12]);
      s = getYN (msg, "Fine", "Chance");
      if (s) {
	printf ("Paying the Fine...\n");
	Cash[player] -= value[i];
	FreeParking += value[i];
	printf ("Cash is %d \n", Cash[player]);
	send_structured_packet (CASH, player, Cash[player], "");
	send_structured_packet (FREEPARKING, 0, FreeParking, "");
      }
      else {
	if (text == 1)
	  printf ("Taking a Chance...\n");
	chance (player);
      }
    }
    break;
  case 13:{
      int j;
      for (j = 1; j <= NoOfPlayers; j++)
	if (j != player) {
	  Cash[j] -= 10;
	  Cash[player] += 10;
	  send_structured_packet (CASH, j, Cash[j], "");
	}
      send_structured_packet (CASH, player, Cash[player], "");
    }
  case 14:
    OutOfJailFree[player]++;
    break;
  case 15:
    InJail[player] = 1;
    move_player (player, 10);
    send_structured_packet (JAIL, player, 1, "");
    send_structured_packet (LOCATION, player, Location[player], "");
    break;
  }
}

void SystemSquare (int player, int loc)
{
  Square s;

  s = Board[loc];
  switch (s.Colour) {
  case 0:			// Go
    sprintf (note, "You have landed on %s! Receive 400.\n", Board[0].Name);
    notify (note);
    if (text == 0) {
      gui_show_text ("Landed on Go!", note, strlen (note), 200, 70);
    }
    if ((rules & RULE_400_FOR_GO) == RULE_400_FOR_GO)
      Cash[player] += 400;
    else
      Cash[player] += 200;
    send_structured_packet (CASH, player, Cash[player], "");
    break;
  case 1:			// Chance
#ifdef DEBUG
    printf ("Take a Chance!\n");
#endif
    chance (player);
    break;
  case 2:			// Community Chest
#ifdef DEBUG
    printf ("Community Chest.\n");
#endif
    community_chest (player);
    break;
  case 3:			// Income Tax
    sprintf (note, "Income tax - %d.\n", s.Cost);
    notify (note);
    if (text == 0)
      gui_show_text ("Income Tax", note, strlen (note), 200, 70);
    Cash[player] -= s.Cost;
    FreeParking += s.Cost;
    send_structured_packet (FREEPARKING, 0, FreeParking, "");
    send_structured_packet (CASH, player, Cash[player], "");
    send_structured_packet (INFO, 0, 0, note);
    break;
  case 4:			// Go To Jail
    sprintf (note, "Go To %s.\nGo directly to %s.\nDo not pass %s.\nDo not collect 200.\n", Board[10].Name, Board[10].Name,
	     Board[0].Name);
    notify (note);
    threw_double = 0;
    if (text == 0)
      gui_show_text ("Go to Jail", note, strlen (note), 200, 70);
    InJail[player] = 1;
    move_player (player, 10);
    send_structured_packet (JAIL, player, 1, "");
    send_structured_packet (LOCATION, player, Location[player], "");
    break;
  case 5:			// Free Parking
    if ((rules & RULE_FREE_PARKING) == RULE_FREE_PARKING) {
      sprintf (note, "You Landed on Free Parking - you get %d\n", FreeParking);
      notify (note);
      if (text == 0)
	gui_show_text ("Free Parking", note, strlen (note), 200, 70);
      Cash[player] += FreeParking;
      FreeParking = 50;
      send_structured_packet (FREEPARKING, 0, FreeParking, "");
      send_structured_packet (CASH, player, Cash[player], "");
    }
    break;
  case 6:			// Jail
    if (InJail[player] >= 1)
      printf ("JAIL: In Jail\n");
    else
      printf ("JAIL: Just Visiting.\n");
    break;
  }
}

void play_game ()
{
  int prevloc;

#ifdef DEBUG
  printf ("Starting play_game()\n");
  printf ("MyPlayerNum=%d, NoOfPlayers=%d, Player=%d, Master=%d.\n", MyPlayerNum, NoOfPlayers, Player, Master);
#endif
  display_board (NoOfPlayers, 0);
  do {
#ifdef DEBUG
    printf ("THREW_DOUBLE : %d\n", threw_double);
#endif
    if (text == 1) {
      if (threw_double > 0) {
	printf ("%s has another go.\n", Names[Player]);
      }
    }
    logstat (Player);
    outofjail (Player);
    if (InJail[Player] == 0) {
      interact (Player);	/* Activate the interaction stuff */
      dice_val = shake ();
      if ((threw_double == 3) && ((rules & RULE_THREE_AND_IN) == RULE_THREE_AND_IN)) {
	if (text == 0) {
	  char *msg = "You threw three doubles.\nGo to Jail.";
	  gui_show_text ("Go To Jail", msg, strlen (msg), 200, 100);
	}
	InJail[Player] = 1;
	move_player (Player, 10);
	send_structured_packet (JAIL, Player, 1, "");
	send_structured_packet (LOCATION, Player, Location[Player], "");
      }
    }
    if (InJail[Player] == 0) {
      if (text == 1)
	printf ("Shakes %d... ", dice_val);
      prevloc = Location[Player];
      move_player (Player, Location[Player] + dice_val);
      send_structured_packet (LOCATION, Player, Location[Player], "");
      landed_on_square (Player, Location[Player]);
      if ((threw_double > 0) && (threw_double < 3) && (text == 0)) {
	char *msg = "You threw a double.\nHave another go.";
	gui_show_text ("Threw a Double", msg, strlen (msg), 200, 100);
	send_structured_packet (INFO, 0, 0, "Threw a double; having another go.\n");
      }
    }				// else - ie, not in Jail due to three doubles
  } while ((threw_double > 0) && (InJail[Player] == 0));
  logstat (Player);
  next_player ();
  /*
     Our go is over; we must now update the other players to tell them
     what has happened...
   */
  sprintf (note, "Handing over to %s...\n", Names[Player]);
  notify (note);
#ifdef DEBUG
  printf ("%s", note);
#endif
  send_structured_packet (PLAYER, 0, Player, "");
  if (MyPlayerNum == Master) {
    if (text == 0) {
      // switch to listen to the active player
      gtk_input_remove (interrupt);
      //interrupt=gtk_input_add(mysocket[Player], GDK_INPUT_READ, receive_structured_packet, 0);
      interrupt = add_input (Player);
    }
    else {
#ifdef DEBUG
      printf ("play_game calling receive_structured packet\n");
#endif
      receive_structured_packet ();
    }
  }
}

int main (int argc, char *argv[])
{
  int master;
  int res = 0;

  MYPORT = 6010;
  MyPlayerNum = 1;
  Master = 1;
  Player = 1;
  text = 1;			/* for startup */
  init_board ();
  init_game (MAXPLAYERS);
  master = get_players (argc, argv);
  if (master == -1)
    return 1;
/*
	Note that this affects how we play the game only slightly; we are still free
	to leave the game, lose and quit, etc. 
*/
  display_board (NoOfPlayers, 0);
  while (1) {			/* while 1 for testing... */
    threw_double = 0;
    printf ("%s's turn.\n", Names[Player]);
    if (Player == MyPlayerNum) {
#ifdef DEBUG
      printf ("My turn; threw_double=%d\n", threw_double);
#endif
      play_game ();
    }
    else {
      /* Find out what happened ... receive packets until we get one saying whose turn it is next...  */
      res = 0;
      while (res == 0) {
#ifdef DEBUG
	printf ("main() calling receive_structured_packet...\n");
#endif
	res = receive_structured_packet ();
	//display_board (NoOfPlayers, 0);
      }
      Player = res;
#ifdef DEBUG
      printf ("Player=%d, MyPlayerNum=%d.\n", Player, MyPlayerNum);
#endif
    }
  }

  return 0;
}
