#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>          
#include <errno.h>
#include <gtk/gtk.h>
#include <unistd.h>

#include "rules.h"

#define PLAYER 1
#define BOARD 2
#define CASH 3
#define HOUSE 4
#define OWNS 5
#define FREEPARKING 6
#define JAIL 7
#define LOCATION 8
#define MORTGAGED 9
#define QUIT 10
#define CHAT 11
#define DICE 12
#define INFO 13
#define TEST 120

#define MAXPLAYERS 9

struct sockaddr_in your_addr[MAXPLAYERS];
struct in_addr myip;
int mysocket[MAXPLAYERS];
int rules;

char Names[MAXPLAYERS][20];
void SystemSquare(int Player, int loc);

typedef struct {
        char Name[30];
        int Cost;
        int MortgageValue;
        int CostofHouses;
        int NoOfHouses; // 5=Hotel
        int Rent[6]; // Cost with 0..5 houses
        int OneOtherInSet;  // the one (or two) other locations
        int TwoOtherInSet;  // in the set (must own set for double
                // rent or to build houses). Also needed for checking
                // ratios of houses (not allowed 1-1-3 on a set)
        int ThirdOtherInSet; // Only for Stations...
        int Colour;
        int Mortgaged;
        } Square;

typedef struct {
	char pkttype, index;
	gint32 val;
	char sval[200];
	} structured_packet;

Square Board[40];
char log[200];
char server[20];
int FreeParking;
int InJail[MAXPLAYERS];
int Quit[MAXPLAYERS];
int OutOfJailFree[MAXPLAYERS];
int Location[MAXPLAYERS];           // Who'se where?
int Lap[MAXPLAYERS];        // =0; =1 when you pass Go...
int Cash[MAXPLAYERS];
int Owns[40];
int MYPORT;
int NoOfPlayers;
int dice_val;
int threw_double;
int Master;
int MyPlayerNum;
//int DEBUG;                                             
int Player;
int FIRSTLAP;
int text;
int interrupt;
GtkWidget *pixmapwid[MAXPLAYERS];
GtkWidget *box[40];
GtkWidget *button[40];
GtkWidget *mytext;
GtkWidget *cashtxt[MAXPLAYERS];
GtkWidget *loctxt[MAXPLAYERS];
GtkWidget *fixed;
GtkWidget *window;
GdkFont *fixed_font;
GdkFont *small_font;
char YN[50];
char note[200];
GtkWidget *interact_dialog;
GtkWidget *dicewidgets[2];
GtkWidget *diceboxes[2];



// Function declarations.
// It would be very nice and tidy to do these in different headers,
// but it's easiest to do it this way. The files aren't all that well
// segregated anyway.
int audit (int player);
void gui_show_text (char *titlebar, char *buf, int len, int x, int y);
void gui_show_houses (int loc);
void move_pointer (int player, int loc);
void gui_start (int argc, char **argv);
int receive_structured_packet ();
void text_show_street (int loc);
void gui_show_street (int loc);
int own_set (int player, int i);
int text_what_do_i_own (int player, int verbose);
int gui_what_do_i_own (int player, int verbose);
int getnum (char *msg);
char text_getYN (char *msg, char *Y, char *N);
void gui_getYN (char *msg, char *Y, char *N);
char getYN (char *msg, char *Y, char *N);
void gui_show_owns_street (int location, int player);
int gui_chat (int *p, char *msg);
void gui_buy_sell_houses ();
void gui_buy_sell_mortgage (int Player);
void add_interact_dialog ();
void gui_show_dice (int die0, int die1);
int add_input (int p);
void send_structured_packet (int pkttype, int index, int val, char *sval);
void open_port (int player);
int send_packet (void *buf, int player, int len);
void close_port (int player);
int receive_update();
int start_receive ();
void master_wait_on_players ();
void gui_update_cash ();
int process_interact (char *s);
void notify (char *x);
int xloc (int x);
int yloc (int y);
int houses_okay (int i, int proposed);
char *colour_name (int i);
int receive_packet (void *buf, int maxlen, int player);
void move_player (int player, int loc);
int get_rent (int i);
void play_game ();
void show_street (int loc);
void gui_outofjail(int p);

int shake();
